#!/usr/bin/perl
# $Id: xlatcfg.pl,v 1.5 2005/12/17 18:27:09 stas_degteff Exp $
# xlatcfg.pl
# Generate xlatcharset directives for the config of Golded+
# using Golded+ charset conversion modules in text form (*.chs).
#
# Format:
# RUS_IBM.CHS   Charset conversion table from RUS to IBMPC

if($#ARGV<1){
   die "Need two parameters: directory witn *.chs (1) and output file name (2)\n";
}

if( -f $ARGV[1] ){
   die "File '$ARGV[1]' is exists, exiting\n";
}

if( ! -d $ARGV[0] ){
   die "Directory '$ARGV[1]' is not exists, exiting\n";
}
my $dir=$ARGV[0], $out=$ARGV[1];

my @files=<$dir/*.chs>;

if( $#files < 0 ){
 die "$dir/ don't contains files like *.chs, exit\n";
}
open OUT, ">$out" || die "Can't open/create file '$out': $!\n";

print "Found " . ($#files+1) . " *.CHS files in $dir\n";

foreach my $f (@files) {
  if( ! open( IN, "$f" ) ){ print STDERR "Can't open file '$f': $!\n"; next; }
  print "Proceed $f\n";
  my $count=1, $fromchs, $tochs;
  $f =~ s%.*/%%g;
  while( <IN> ) {
     next if( /^;/ ); # comment
     next if( m%^//% ); # comment
     next if( m%^#% ); # comment
     chomp;
     next if( m%^$% ); # empty line
     if( m%^([^\s]+)% ) {
       if($count==4){ $fromchs=uc($1); }
       elsif($count==5){
         $tochs=uc($1);
         printf OUT " %-14s Charset conversion table from %s to %s\n", $f, $fromchs, $tochs;
       }
       $count++;
     }
  }
  close IN;
}

close OUT;
